;Secte delky vsech vybranych usecek, krivek a oblouku
;modified CAD Studio, 2000 (MLINES)
;

;opravena funkce (add_poly) - alfred - mereni delky u krivek v Civilu 3D 2010

(defun REMOVE-IF-NOT (pred lst)
  (apply 'append
         (mapcar '(lambda (e)
                 (if (apply pred (list e)) (list e))) lst))
)
                 
(defun group-only (grp lst)
  (mapcar 'cdr (remove-if-not '(lambda(pair)(= grp (car pair))) lst))
)

(defun add_mlines ( / pt)
 (setq pto (car (group-only 11 ed)))
 (foreach pt (group-only 11 ed) (progn (setq tot_len (+ tot_len (distance pt pto)))(setq pto pt)))
 (ssdel en ss)
)

(defun add_lines ()
  (setq pt1 (cdr (assoc '10 ed)))
  (setq pt2 (cdr (assoc '11 ed)))
  (setq line_len (distance pt1 pt2))
  (setq tot_len (+ tot_len line_len))
  (ssdel en ss)
)

(defun add_arcs ()
  (SETQ CEN (CDR (ASSOC '10 Ed))
        RAD (CDR (ASSOC '40 Ed))
        DIA (* RAD 2.0)
        CIRCUM (* (* RAD PI) 2.0)
        S_ANG (CDR (ASSOC '50 Ed))
        E_ANG (CDR (ASSOC '51 Ed))
  )
  (IF (< E_ANG S_ANG)
    (SETQ E_ANG (+ E_ANG (* PI 2.0)))
  )
  (SETQ
        N_ANG (- E_ANG S_ANG)
        N_ANG_1 (* (/ N_ANG PI) 180.0)
        PART_CIRC (/ N_ANG_1 360.0)  
        A_LEN (* PART_CIRC CIRCUM)
  )
  (setq tot_len (+ tot_len a_len))
  (PRIN1)
  (SSDEL EN SS)
)

(defun add_poly ( / vlaobj)
  ;********* Alfred - zacatek opravy
  ;(command "_area" "_e" en)
  ;(setq tot_len (+ tot_len (getvar "perimeter")))
  (vl-load-com)
  (setq vlaobj (vlax-ename->vla-object en))
  (setq tot_len (+ tot_len 
      (vlax-get-property vlaobj 'Length)
  ))
  ;********* Alfred - konec opravy
  (ssdel en ss)
  
)

(DEFUN C:addlen ( / e_type)
  (setq en nil)
  (setq ss nil)
  (setq tot_len 0)  
  (prompt "\nVyberte vechny objekty pro vpoet: ")
  (setq ss (ssget))
  (while (> (sslength ss) 0)
    (print "cykl")
    (setq en (ssname ss 0))
    (setq ed (entget en))
    (setq e_type (cdr (assoc '0 ed)))
    (cond
      ((= e_type "LINE") (add_lines))
      ((= e_type "MLINE") (add_mlines))
      ((= e_type "ARC") (add_arcs))
      ((= e_type "POLYLINE") (add_poly))
      ((= e_type "LWPOLYLINE") (add_poly))
      ((= e_type "SPLINE") (add_poly))
      ((or
	 (/= e_type "LINE")
	 (/= e_type "MLINE")
	 (/= e_type "ARC")
	 (/= e_type "POLYLINE")
	 (/= e_type "LWPOLYLINE")
	 (/= e_type "SPLINE")
       )
       (ssdel en ss)
      )
    )
  )
  (print (strcat "\nCelkov dlka je: " (rtos tot_len 2 2)))
  (setq en nil)
  (setq ss nil)
(princ)
)
