;;;CADALYST 05/05 Tip 2032: 		Check_Text.lsp	Spell Check 	(c) 2005 Andrzej Gumula


;;; [c]2004 Andrzej Gumula, Katowice, Poland
;;; e-mail: a.gumula@wp.pl
;;; This routine allows automatically check autocad texts in Microsoft Word
;;; Perfect for national version of AutoCAD (like polish, germany, french, spanish...)

(defun c:CheckText (/ TxtSet Word Docs NewDoc Paragraphs Range
                       NewTxtList OldTxtList IdTxtList FontName Txt Count)

(defun vla-List-Layers-Locked (/ Each Out)
 (vlax-for Each 
   (vla-get-Layers (vla-get-activedocument (vlax-get-acad-object)))
     (if (equal (vlax-get-property Each 'Lock) :vlax-true)
         (setq Out (cons (vla-get-Name Each) Out))
     )
 )
(if (not Out) (setq Out (list "")))
Out
);end vla-List-Layers-Locked

(defun list->str (LayList / String)
 (foreach Count LayList 
  (if (not String) (setq String Count)
    (setq String (strcat String "," Count))
  );end if
 )
);end list->str

(defun Dxf (Index)
 (cdr (assoc Index (entget (ssname TxtSet Count))))
);end Dxf

(defun FilterSSet (/ Item Obj)
  (repeat (setq Item (sslength TxtSet))
   (setq Item (1- Item)
	 Obj (ssname TxtSet Item))
   (if (distof (cdr (assoc 1 (entget Obj)))) (ssdel Obj TxtSet))
  );end repeat
  TxtSet
);end FilterSSet

(setq TxtSet
 (ssget "_X" 
    (list '(-4 . "<AND")
           '(-4 . "<NOT")
              (cons 8 (list->str (vla-List-Layers-Locked)))
           '(-4 . "NOT>")
           '(0 . "*TEXT") 
          '(-4 . "AND>")
    )
 )
)
(if TxtSet (setq TxtSet (FilterSSet)))
(cond 
 ((and TxtSet (> (sslength TxtSet) 0))
  (vl-load-com)
  (cond
   ((setq Word (vlax-get-or-create-object "Word.Application"))
   (if (= (vla-get-visible Word) ':vlax-false)  (vla-put-visible Word :vlax-true))
   (vla-put-WindowState Word 1)
   (vla-activate Word)
   (setq Docs (vla-get-documents Word)
         NewDoc (vlax-invoke-method Docs 'add)
         Paragraphs (vlax-get-property NewDoc 'paragraphs))  
   (repeat (setq Count (sslength TxtSet))
    (setq Count (1- Count)
          FontName (vl-filename-base (cdr (assoc 3 (tblsearch "STYLE" (Dxf 7)))))
          Range (vlax-get-property (vlax-get-property Paragraphs 'last) 'range))
    (vlax-put-property (vlax-get-property Range 'Font) 'Name FontName)
    (vlax-invoke-method Range 'InsertAfter 
     (if (= Count 0) 
      (Dxf 1) 
      (strcat (Dxf 1) "\n")
     );end if
    )
    (setq OldTxtList (cons (Dxf 1) OldTxtList)
          IdTxtList (cons (Dxf -1) IdTxtList)
    )
   );end repeat
   (vlax-invoke-method NewDoc 'CheckSpelling nil 0 1)
   (repeat (setq Count (vla-get-count Paragraphs))
    (setq Txt (vlax-get-property
              (vlax-get-property (vla-Item Paragraphs Count) 'range) 'text)
          NewTxtList (append NewTxtList (list (substr Txt 1 (1- (strlen Txt)))))
          Count (1- Count))
   );end repeat
   (mapcar '(lambda (x y z) 
    (if (/= x y) (entmod (subst (cons 1 x) (cons 1 y) (entget z))))) 
    NewTxtList OldTxtList IdTxtList
   )   
   (vla-quit Word 0)
   (prompt "\nKontrola pravopisu byla dokonena!")
   )
   (T (prompt "\nMicrosoft Word nen na tomto potai nainstalovn. "))
  );end cond Word
 )
 (T (prompt "\nNenalezen dn text nebo je text umstn v uzamknutch hladinch.\n"))
);end cond

 (princ)
);end file


(prompt "\nNaten pkaz CheckText. ")
(prompt "\n[c]2004, Andrzej Gumula. ")
(princ)

