;=========================================================================
; Izolace.lsp    Vykresl zvolen druh izolace
; (c) Copyright 2007 PepaR
; Version:   1.2
;-------------------------------------------------------------------------
; Description:
;
; Vlo blok do hladiny "KOTY" nebo "POPIS" s monost nastaven atribut.
;
; Command options:
;  "IZOLACET"    Kresl tepelnou izolaci
;  "IZOLACEZ"    Kresl zvukovou izolaci
;  "IZOLACEH"    Kresl hydroizolaci
;============================================================================
; nastaven kreslen tepeln izolace
;============================================================================
(defun izol_tep-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "_BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (if (not (tblsearch "layer" "SRAFY"))
    (progn
      (command "_LAYER" "_Make" "SRAFY" "_Color" "8" "SRAFY" "")
      (prompt "\nVytvoena hladina SRAFY - barva 8 (ed).")
    ) ; progn
  ) ; if
  (command "_LAYER" "_S" "SRAFY" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "IZOLACET" ""
  )
)

(defun izol_tep-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; nastaven kreslen zvukov izolace
;============================================================================
(defun izol_zvuk-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "_BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (command "_LAYER" "_S" "SRAFY" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "IZOLACEZ" ""
  )
)

(defun izol_zvuk-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; nastaven kreslen hydroizolace
;============================================================================
(defun izol_hydro-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vych_hlad (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "_BYLAYER")
  )
  (if (= (setq vych_cara (getvar "CELTYPE")) "BYLAYER")
            (setq vych_cara "BYLAYER")
  )
  (command "_LAYER" "_S" "KCE POD" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "_BYLAYER" ""
  )
  (command "_MLINE" "Z" "S" "M" (getvar "dimscale") "S" "HYDROIZOLACE" "")
)

(defun izol_hydro-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vych_hlad ""
           "_COLOR" barva
           "_LINETYPE" "_S" vych_cara ""
  ) ; command
  (setvar "cmdecho" echo)
  (princ)
)
;============================================================================
; Kreslen tepeln izolace
;============================================================================
(defun C:IZOLACET ()
  (princ "\nTlouka izolace 100mm -> Mtko typu ry = 1.0\n            Izolace je kreslena osou                ")
  (izol_tep-start)
  (setq point (getpoint "\nPrvn bod: "))
    (command "_PLINE")
    (while point
    (command point)
  (setq point (getpoint point "\nDal bod: "))
  )
  (command "")
  (izol_tep-end)
  (princ)
)
;============================================================================
; Kreslen zvukov izolace
;============================================================================
(defun C:IZOLACEZ ()
  (princ "\nTlouka izolace 100mm -> Mtko typu ry = 1.0\n            Izolace je kreslena osou                ")
  (izol_zvuk-start)
  (setq point (getpoint "\nPrvn bod: "))
    (command "_PLINE")
    (while point
    (command point)
  (setq point (getpoint point "\nDal bod: "))
  )
  (command "")
  (izol_zvuk-end)
)
;============================================================================
; Kreslen hydroizolace
;============================================================================
(defun C:IZOLACEH ()
  (princ "\nIzolaci kreslete na rozhran materil -> NE jako novu vrstvu\n            Izolace je kreslena osou                ")
  (izol_hydro-start)
  (setq point (getpoint "\nPrvn bod: "))
  (command "_MLINE")
    (while point
    (command point)
  (setq point (getpoint point "\nDal bod: "))
  )
  (command "")
  (izol_hydro-end)
)

