;=========================================================================
; Mistnost.lsp    Popis mstnosti
; (c) Copyright 2006 PepaR
; Version:   1.0
;-------------------------------------------------------------------------
; Author:    Chop & PepaR
; Translate: -
;
; Description:
; Zjist plochu a obvod mstnosti a zape jej jako atributy do bloku
;
; Command options:
;  "MISTNOST" Spust slovn mstnost
;
;============================================================================

(defun mistnost_zjisti (/ celk_obvod celk_plocha plocha obvod i ss)
  (setq celk_obvod 0.0)
  (setq celk_plocha 0.0)
  (prompt "\nVyberte kivku(y) mstnosti: ")
  (setq ss (ssget (list (cons -4 "<OR") (cons 0 "POLYLINE") (cons 0 "LWPOLYLINE") (cons -4 "OR>")   )) i 0)
  (while (< i (sslength ss))
    (command "_area" "_e" (ssname ss i))
    (setq celk_obvod (+ celk_obvod (getvar "perimeter")))
    (setq celk_plocha (+ celk_plocha (getvar "area")))
    (setq i (1+ i))
  )

  (setq plocha (vl-string-subst "," "."  (rtos (/ celk_plocha (* 1000.0 1000.0)) 2 2)))   ;;; Prevod na mm^2 -> m^2
  (setq obvod (vl-string-subst "," "."  (rtos (/ celk_obvod 1000.0) 2 2)))                ;;; Prevod na mm -> m

  (list plocha obvod)
)

(defun mistnost_zapis (entl mcislo mnazev mplocha mobvod / e eg)
 (setq e (entnext entl))
 (while e
  (setq eg (entget e))
  (if (= (cdr (assoc 0 eg)) "ATTRIB")
   (progn

    (if (= (cdr (assoc 2 eg)) "PLOCHA")
     (progn
       (setq eg (subst (cons 1 mplocha) (assoc 1 eg) eg))
       (entmod eg)
     )
    )

    (if (= (cdr (assoc 2 eg)) "OBVOD")
     (progn
       (setq eg (subst (cons 1 mobvod) (assoc 1 eg) eg))
       (entmod eg)
     )
    )

    (if (and (= (cdr (assoc 2 eg)) "CISLO") mcislo)
     (progn
       (setq eg (subst (cons 1 mcislo) (assoc 1 eg) eg))
       (entmod eg)
     )
    )

    (if (and (= (cdr (assoc 2 eg)) "NAZEV") mnazev)
     (progn
       (setq eg (subst (cons 1 mnazev) (assoc 1 eg) eg))
       (entmod eg)
     )
    )

   )
  )
  (setq e (entnext e))
 ) 
(princ)

)

;;; Pozor, entlast za urcitych okolnosti nevraci posledni entitu (je-li jako posledni entita napr. blok s atributy nebo polyline)
(defun entlast1 (/ e en)
 (setq en (entlast))
 (while en
  (setq e en)
  (setq en (entnext en))
 )
 e
)


(defun C:MISTNOST (/ entl entl1 attrq mcislo mnazev param)
  (setq attrq (getvar "ATTREQ"))
  (setvar "ATTREQ" 0)

  (setq entl1 (entlast1))
  (setq entl (entlast))

  (setq param (mistnost_zjisti))
  (setq mcislo (getstring "\nslo mstnosti: "))
  (if (= mcislo "") (setq mcislo "0.00"))
  (setq mnazev (getstring "\nNzev mstnosti: "))
  (prompt "\nUrete bod vloen popisu mstnosti :")
  (command "_-INSERT" "Cislo_mistnosti" pause (getvar "dimscale")(getvar "dimscale") pause)
  (mistnost_zapis entl1 mcislo mnazev (car param) (cadr param))
  (entupd (entlast))

  (setvar "ATTREQ" attrq)
  (princ)
)