;;;	TXTcount.lsp
;;;	Modified by Ing. Jozef Lovas, PhD.	13.11.2005
;;;	Counts all the Texts and Mtexts from selecion set or from all the drawing.

;;;	This LSP was writen by using and modifying of the following files:

;;;    	COUNT.LSP	Copyright  1999 by Autodesk, Inc.
;;;	&
;;; 	MTEXTCF.LSP   (c) 12.4.1999 Jan Bastecky


(defun c:TXTcount (/ ss flt a n lst)
  (acet-error-init
    (list nil T)
  )					;acet-error-init

  (setq txt_max_length 15)		;restriction to max length of text string

  (setq	flt (append '((-4 . "<OR")
		      (0 . "MTEXT")
		      (0 . "TEXT")
		      (-4 . "OR>")
		     )
	    )				;append
  )					;setq
  (acet-ss-clear-prev)
  (princ "\nStisknte Enter pro vbr veho nebo...")

  (if (setq ss (ssget))
    (setq ss (ssget "_p" flt))
    (setq ss (ssget "_x" flt))
  )					;if
  (if ss
    (bns_count ss)
    (princ "\nNeplatn vbr objekt.")
  )					;if


  (acet-error-restore)
)					;defun c:count

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun bns_count (ss / cnt en el bna lst na e1 n a mx txt txtlist)

  (if SS
    (progn
      (setq CNT (sslength SS))


      ;; Loop through the selection set.
      ;;
      (repeat CNT
	(setq CNT (1- CNT)
	      ;;started at the end of the set
	      EN  (ssname SS CNT)
	      ;;get entity name
	      EL  (entget EN)
	      ;;get entity list
	      TXT (MTEXTCF0 (cdr (assoc 1 el)))	; remove MText formating
	)
	(if (<
	      (strlen TXT)
	      txt_max_length
	    )
	  (setq txtlist (append txtlist (list txt)))
	)
      )
    )
  )


					;get a list of all TEXT and MTEXT
  (setq mx 1)
  (setq n 0)
  (repeat (length txtlist)
    (setq bna (nth n txtlist)
	  mx  (max mx (strlen bna))
    )					;setq
    (if	(not (assoc bna lst))
      (setq lst (cons (cons bna 1) lst))
      (setq a	(cdr (assoc bna lst))
	    a	(+ a 1)
	    lst	(subst (cons bna a) (assoc bna lst) lst)
      )					;setq
    )					;if
    (setq n (+ n 1))			;setq
  )
					;defun bns_count

  (setq lst (reverse lst))
  (if lst
    (progn
      (setq mx (+ mx 5))		;setq
      (princ (bns_count_format "Text" "Poet" mx))
      (setq a "\n")
      (while (< (strlen a) (+ mx 7))
	;;      (setq a (strcat a "-"))
	(setq a (acet-str-format "%1-" a))
      )					;while
      (princ a)
    )					;progn then print header
  )					;if
  (setq n 0)
  (repeat (length lst)
    (setq a (nth n lst))		;setq
    (princ (bns_count_format (car a) (itoa (cdr a)) mx))
    (setq n (+ n 1))			;setq
    (princ)
  )					;repeat
)					;defun bns_count


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun bns_count_format	(a b mx /)

  (while (<= (strlen a) mx)
    ;;  (setq a (strcat a "."))
    (setq a (acet-str-format "%1." a))
  )					;while
  ;; (setq a (strcat "\n" a b))
  (setq a (acet-str-format "\n%1%2" a b))
)					;defun bns_count_format


(princ)


;;; program MTEXTCF.LSP   (c) 12.4.1999 Jan Bastecky
;;;=================================================================
;;; MTextCleanFormat - odstrani formatovani z MTEXTU
;;; modifikace na koty, 24.1.2001 CAD Studio
;;;

(defun MTEXTCF0	(txr / pozice delka znak ntx)
					; vlastni vykonna funkce, prevadi TXR na NTX
  (setq ntx "")
  (setq pozice 1)
  (setq delka (strlen txr))
  (while (<= pozice delka)
    (setq znak (substr txr pozice 1))
    (if	(= znak "\\")			;pokud je lomitko      
      (progn
	(setq pozice (1+ pozice))	; posunu se na dalsi znak
	(setq znak (substr txr pozice 1))
	(if (or (= znak "{") (= znak "}") (= znak "\\"))
					; bylo druhe lomitko nebo sloz.zavorka?
	  (setq ntx (strcat ntx "\\" znak))
					; ANO -> vysledny znak kopiruji
	  (progn			; NE -> ignoruji znaky az do ";"
	    (while (and (/= znak ";") (<= pozice delka))
	      (setq pozice (1+ pozice))
	      (setq znak (substr txr pozice 1))
	    )
	  )
	)
      )
      (if (and (/= znak "{") (/= znak "}"))
					; pokud neni lomitko ... a neni to ani zavorka
	(setq ntx (strcat ntx znak))	; tak pouze kopiruji vstup
      )
    )
    (setq pozice (1+ pozice))
  )
  (setq ntx ntx)
)

;;;**********************************************************************************************************************
(princ
  "\nPro sputn aplikace zadejte pkaz TXTcount."
)
(princ)