;Text_Align_Vert.lsp                   May 19, 2003        Donald B. Smith, P.E.
;REV: LU.LSP                                JUL 27, 1997        Greg Bernotas
;REV: LINE-UP.LSP                      OCT 9, 1991         Kent Keller
;REV: DINTER                                OCT 9, 1991         P. Legoy
;
;REVISED:  This header and ability to line up any justification
;                     type text along the y-axis more efficently.  The x and
;                     y line-up options were broken out into 2 seperate lisp
;                     files for quick pick action.  See Text_Align_Vert.LSP
;                     for lining up text more efficiently along the x-axis.
;
;PURPOSE: This routine allows user to line up ANY existing
;                      text within a drawing along the Horizontal (Y) axis.
;
;ACTION:  Initate routine with "tav".
;
(prompt "\nText_Align_Vert.lsp naten.")

(defun c:TAV (/ XORY PSET NU OLDECHO LINE-UP ENT VALUE
               NU CT X X2 Y Y2 f f2)
   
   (= XORY "Y")

   (setq VALUE (cadr (getpoint "\nUrete horizontlu pro zarovnn: ")))

   (grdraw (list (car (getvar "vsmin"))value)
       (list (cadr (getvar "vsmax"))value) -3 1)

   (defun LINE-UP (ENT XORY VALUE)
      (setq x (cadr (assoc 10 ENT)))
      (setq x2(cadr (assoc 11 ENT)))
      (setq y (caddr (assoc 10 ENT)))
      (setq y2(caddr (assoc 11 ENT)))
      (setq f (cdr (assoc 72 ENT)))
      (setq f2(cdr (assoc 73 ENT)))
     
      (= XORY "Y")

      (and (= f 0) (= f2 0))
      (setq ENT (subst (list 10 x VALUE) (assoc 10 ENT) ENT))
      (setq ENT (subst (list 11 x2 VALUE) (assoc 11 ENT) ENT)) (entmod ENT)
       
     )

   (setq PSET (ssget))
   (if (/= PSET nil)
       (progn
          (SETQ NU 0)
          (while (/= (ssname pset NU) nil)
                 (setq CT (ENTGET (ssname PSET NU)))
                 (if (equal (cdr (assoc 0 CT)) "TEXT")
                     (LINE-UP CT XORY VALUE)
                 )
                 (SETQ NU (+ NU 1))
          )
       )
   )
   (redraw)
   (setvar "cmdecho" 1)
   (princ)
)
(prompt "\nFunkci spustte pkazem TAV")
(princ)
