	;                                                                         ;
	; CREATED       ||   || || || //  |||                                     ;
	;        |||||  ||   || || ||||  || ||  |||||                             ;
	;   by          ||||  |||  || \\  |||                                     ;
	;                                                                         ;
	;                                                   copyright -LuK.O.-    ;

;                                                                                 ;
;         EXPORT SOUADNIC 2D/3D KIVKY (POLYLINE) nebo SPLINE DO SOUBORU         ;
;                                                                                 ;

(defun style(/ blk)
  (setq blk (tblsearch "style" (getvar "textstyle"))) ; zjisti, zda je nastavena velikost textu na tvrdo, jinak si ji najde v textsize
  (setq txtHeight (cdr (assoc 40 blk)))
) ;defun

(defun c:bk(/ oldcmdecho ent ent1 soubor f cntr n rok mes den hodina minuta vterina i txtHeight cisla1)
  (setq oldcmdecho (getvar "cmdecho"))
  (princ "\nVyberte 2D/3D kivku (polyline) nebo spline: ")
  (setq ent (ssget '((-4 . "<OR")(0 . "LWPOLYLINE")(0 . "POLYLINE")(0 . "SPLINE")(-4 . "OR>"))))
  (while (not ent)
    (princ "\nNebyla vybrna 2D/3D kivka ani spline. Vyberte 2D/3D kivku (polyline) nebo spline: ")
    (setq ent (ssget '((-4 . "<OR")(0 . "LWPOLYLINE")(0 . "POLYLINE")(0 . "SPLINE")(-4 . "OR>"))))
  ) ;while
  (setq soubor (getfiled "Nzev souboru pro souadnice" "c:/" "txt" 1))
  (if (not soubor)
    (exit)
  ) ;if
  (initget "Ano Ne")
  (setq cisla1 (if (null cisla) "Ano" cisla))
  (setq cisla (getkword (strcat "\nslovat body ve vkrese [Ano/Ne] <" cisla1 ">: ")))
  (if (not cisla) (setq cisla cisla1))
  (setq f (open soubor "a"))
  (setq rok (substr (rtos (getvar "cdate") 2 14) 1 4))
  (setq mes (substr (rtos (getvar "cdate") 2 14) 5 2))
  (setq den (substr (rtos (getvar "cdate") 2 14) 7 2))
  (setq hodina (substr (rtos (getvar "cdate") 2 14) 10 2))
  (setq minuta (substr (rtos (getvar "cdate") 2 14) 12 2))
  (setq vterina (substr (rtos (getvar "cdate") 2 14) 14 2))
  (write-line "!***** CREATED BY -LUKO- *****" f)
  (write-line (strcat "!" den "." mes "." rok ", " hodina ":" minuta ":" vterina) f)
  (setq cntr 0)
  (setvar "cmdecho" 0)
  (while (< cntr (sslength ent))
    (write-line (strcat "!***** ZATEK " (rtos (1+ cntr) 2 0) ". KIVKY *****") f)
    (cond
      ((= (cdr (assoc 0 (entget (ssname ent cntr)))) "LWPOLYLINE")
       (progn
	 (write-line "!***** 2D KIVKA (2D POLYLINE) *****" f)
	 (setq ent1 (entget (ssname ent cntr)))
	 (setq i 1)
	 (foreach n ent1
	   (progn
	     (if (= (car n) 10)
	       (progn
		 (write-line (strcat (rtos i 2 0) " , " (rtos (cadr n) 2 3) " , " (rtos (caddr n) 2 3)) f)
	         (style)
      	         (if (= cisla "Ano")
		   (if (= txtHeight 0.0)
		     (command "_text" "_justify" "_bl" (cdr n) (getvar "textsize") "0" (rtos i 2 0))
	             (command "_text" "_justify" "_bl" (cdr n) "0" (rtos i 2 0))
	           ) ;if
                 ) ;if
		 (setq i (1+ i))		 
	       ) ;progn
	     ) ;if
           ) ;progn
         ) ;foreach
       ) ;progn
      ) ;LWPOLYLINE
      ((= (cdr (assoc 0 (entget (ssname ent cntr)))) "POLYLINE")
       (progn
	 (write-line "!***** 3D KIVKA (3D POLYLINE) *****" f)
	 (setq ent1 (entnext (ssname ent cntr)))
         (setq n 1)
         (while (/= (cdr (assoc 0 (entget ent1))) "SEQEND")
           (write-line (strcat (rtos n 2 0) " , " (rtos (cadr (assoc 10 (entget ent1))) 2 3) " , " (rtos (caddr (assoc 10 (entget ent1))) 2 3) " , " (rtos (cadddr (assoc 10 (entget ent1))) 2 3)) f)
           (style)
           (if (= cisla "Ano")
	     (if (= txtHeight 0.0)
	       (command "_text" "_justify" "_bl" (cdr (assoc 10 (entget ent1))) (getvar "textsize") "0" (rtos n 2 0))
	       (command "_text" "_justify" "_bl" (cdr (assoc 10 (entget ent1))) "0" (rtos n 2 0))
	     ) ;if
           ) ;if
           (setq ent1 (entnext ent1))
           (setq n (1+ n))
         ) ;while
       ) ;progn
      ) ;POLYLINE
      ((= (cdr (assoc 0 (entget (ssname ent cntr)))) "SPLINE")
       (progn
	 (write-line "!***** SPLINE *****" f)
	 (setq ent1 (entget (ssname ent cntr)))
	 (setq i 1)
	 (setq old (getvar "osnapcoord"))
         (setvar "osnapcoord" 1)
         (foreach n ent1
	   (progn
	     (if (= (car n) 11)
	       (progn
	         (write-line (strcat (rtos i 2 0) " , " (rtos (cadr n) 2 3) " , " (rtos (caddr n) 2 3) " , " (rtos (cadddr n) 2 3)) f)
	         (style)
      	         (if (= cisla "Ano")
	           (if (= txtHeight 0.0)
	             (command "_text" "_justify" "_bl" (cdr n) (getvar "textsize") "0" (rtos i 2 0))
	             (command "_text" "_justify" "_bl" (cdr n) "0" (rtos i 2 0))
	           ) ;if
                 ) ;if
	         (setq i (1+ i))
	       ) ;progn
	     ) ;if
           ) ;progn
         ) ;foreach
	 (setvar "osnapcoord" old)
       ) ;progn
      ) ;SPLINE
    ) ;cond
    (write-line "" f)
    (setq cntr (1+ cntr))
  ) ;while
  (close f)
  (princ (strcat "\nSouadnice uloeny do " soubor))
  (setvar "cmdecho" oldcmdecho)
  (princ)
) ;defun
