; <-----------------------  CL  --------------------------->
; Copy And Mirror with 45 degrees                           
; This utulity mirrors the selected line 90 degrees and     
; takes a copy of it. This will convert a single line to    
; center lines.                                             
;                                                           
; (c) 1994-2006 Taliasoft Ltd. www.taliasoft.com            
; Written by Erhan TOKER                                    
; --------------------------------------------------------->


(defun c:clines(/ p10 p11 mpt x1 y1 z1 d1 a1 p2)
  (setq _objtype nil) ; reset _objtype global variable
  
  (setq _objtype "_")
  
  ; Check if the selected object is LINE or not!

  (while (/= _objtype "LINE")
	 (get_obj "\nVyberte seku:")
	 )
  
  ; Calculate start and end point of seelected line...
  (setq
	 p10 (cdr (assoc 10 _entlst))
	 p11 (cdr (assoc 11 _entlst))
	 )

  ; Calculate midpoint of selected line
  (setq
	 x1 (/ (+ (car p10) (car p11)) 2.0)
	 y1 (/ (+ (cadr p10) (cadr p11)) 2.0)
	 z1 (/ (+ (caddr p10) (caddr p11)) 2.0)
	 mpt (list x1 y1 z1)
	 )
  
  ; Calculate length 
  (setq d1 (distance p10 p11))
  
  ; Calculate angle in ( RADIANS )
  (setq a1 (angle p10 p11))
  
  ; Second point of center line
  (setq p2 (polar mpt (+ a1 (/ pi 4.0)) d1))
  
  ; Execute MIRROR command
  (command "_MIRROR" _ename "" mpt p2 "N")
  
  (princ)
  )


; Function (get_obj)                                        
; Returns type and pickpoint of selected entity             
; --------------------------------------------------------->
; GLOBALS                                                   
; _objtype	:	STRING, object's DXF name           
;			e.g. "LINE", "ARC", "INSERT"        
; _objpick	:	POINT, object's picked point        
;---------------------------------------------------------->

(defun get_obj (prmt / o1 e1 ent1)
  
  (setq o1 (entsel prmt)
	e1 (car o1)
	ent1 (entget e1)
	_objtype (cdr (assoc 0 ent1))
	_objpick (cadr o1)
	_entlst ent1
	_ename e1
	)
  )

(princ)
