(defun c:ddlimits
       (/ dcl_id currwidth currheight endlimits thewidth theheight)
  (setq dcl_id (load_dialog "ddlimits.dcl"))
  (if (not (new_dialog "ddlimits" dcl_id))
    (exit)
  )
  (setq	endlimits  (getvar "limmax")
	currwidth  (car endlimits)
	currheight (cadr endlimits)
  )
  (set_tile "width" (rtos currwidth))
  (set_tile "widthtext" (rtos currwidth))
  (set_tile "height" (rtos currheight))
  (set_tile "heighttext" (rtos currheight))

  (setq	thewidth  (dimx_tile "im")
	theheight (dimy_tile "im")
  )
  (start_image "im")
  (slide_image 0 0 thewidth theheight "limits")
  (end_image)

  (defun settextwidth ()
    (set_tile "widthtext" (get_tile "width"))
    )
  (action_tile "width" "(settextwidth)")

  (defun settextheight ()
    (set_tile "heighttext" (get_tile "height"))
    )
  (action_tile "height" "(settextheight)")

  (defun setall	()
    (setq currwidth  (atof (get_tile "width"))
	  currheight (atof (get_tile "height"))
	  endlimits  (list currwidth currheight)
    )
    (setvar "limmin" (list 0 0))
    (setvar "limmax" endlimits)
  )
  (action_tile "accept" "(setall) (done_dialog)")

  (start_dialog)
  (unload_dialog dcl_id)
  (princ)
)