;; ======================================================
;; Dimension Note - add a modifier note to existing
;;                  associative dimension strings.
;; 
;; Copyright 2002, Mike Lapinski
;;
;; Permission to use, copy, modify, and distribute this software
;; for any purpose and without fee is hereby granted, provided
;; that the above copyright notice appears in all copies and
;; that both that copyright notice and the limited warranty 
;; notice below appear in all supporting documentation.
;; 
;; D I S C L A I M E R   O F   W A R R A N T Y
;; ======================================================
;;
;; THIS PROGRAM IS MADE AVAILABLE ON AN "AS IS" BASIS WITHOUT 
;; WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY 
;; OTHER WARRANTIES WHETHER EXPRESSED OR IMPLIED. I DO NOT 
;; WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
;; UNINTERRUPTED OR ERROR FREE.
;;
;; I SHALL UNDER NO CIRCUMSTANCE BE LIABLE FOR ANY DAMAGES, 
;; INCLUDING BUT NOT LIMITED TO; LOSS OF PROFITS, LOSS OF TIME, 
;; LOSS OF DATA OR BUSINESS INTERRUPTION RESULTING FROM THE USE 
;; OF THE INABILITY TO USE THIS SOFTWARE. THE USER MUST ASSUME 
;; THE ENTIRE RISK OF USING THE PROGRAM.
;;
;; C O P Y R I G H T   N O T I C E   A N D   T R A D E M A R K S
;; =============================================================
;;
;; This program is copyrighted with all rights reserved by 
;; Michael Lapinski. This program is for "PUBLIC DOMAIN" use 
;; and may not be marketed or offered for sale to others.
;;
;;======================================================
;; Function: DN_ShowNote
;; Purpose:  Show note selected from ListBox in EditBox
;;======================================================
;; Translator: PepaR (pepa.forum@centrum.cz)
;; Function update: Chop
;;======================================================
(defun DN_ShowNote (/ lnum lnote)
(set_tile "error" "")
(setq lnum  (get_tile "lb_notes")
      lnote (nth (atoi lnum) dm_notes)
)
(set_tile "eb_note" lnote)
(mode_tile "accept" 2)
(princ)
)
;;======================================================
;; Function: DN_PlaceNote
;; Purpose:  If valid note is input, close dialog box 
;;======================================================
(defun DN_PlaceNote ()
(set_tile "error" "")
(setq dn_modifier (strcase (get_tile "eb_note")))
(if (= dn_modifier " ")
    (set_tile "error" "Neplatn etzec poznmky")
    (done_dialog 1)
)    
)
;;======================================================
;; Function: DN_AppendDim
;; Purpose:  Append note to selected dimension entity
;;======================================================
(defun DN_AppendDim (sset mod placement / cnt len ent dval)
(setq cnt 0
      len (sslength sset)
)
(princ "\nUpravuji vybran kty...")
(while (< cnt len)
   (setq
           en (ssname sset cnt)
          ent (entget en)
         dval (cdr (assoc 1 ent))
   )
   (if (= dval "")
       (setq dval "<>")
   )
   (if (= placement 1) ;above line
       (setq new_val (strcat dval " " mod))
       (progn
        (if (wcmatch dval "*\\X*")
            (setq new_val (strcat dval "\\P" mod))
            (setq new_val (strcat dval "\\X" mod))
        );if
       );progn     
   );if 
   (entmod (subst (cons 1 new_val)(assoc 1 ent) ent))
   (setq cnt (1+ cnt))
);while
(princ "\nDokoneno")
(princ)
)
;;======================================================
;; Main Function - Dimension NOTE
;;======================================================
(defun C:DNOTE (/ cmd$ ss_dims dcl_id dm_notes dn_above)
(princ "\nVyberte text(y) kty pro pravu...")
(setq ss_dims (ssget '((0 . "DIMENSION"))))
(if ss_dims
  (progn
   (setq cmd$ (getvar "cmdecho"))
   (setvar "cmdecho" 0)
   (setq dcl_id (load_dialog "dimnotes.dcl"))
   (if (not (new_dialog "dimnote" dcl_id))(exit))
   (setq dm_notes '("VYSKA(PARAPET)" "MAX" "MIN" "OVIT" "REF" "TEXT"
                    "TYP" "TYPICAL" "VLASTN 1" "VLASTN 2"
                    "ZMNA"
                   ) 
        dn_above   0
   )
   (set_tile "eb_note" "TYP")
   (set_tile "dn_below" "1") ; Set as default
   (start_list "lb_notes")   
   (mapcar 'add_list dm_notes)  
   (end_list)
   (set_tile "lb_notes" "7")
   (action_tile "lb_notes" "(DN_ShowNote)")
   (action_tile "dn_above" "(setq dn_above 1)")
   (action_tile "dn_below" "(setq dn_above 0)")
   (action_tile "accept" "(DN_PlaceNote)")
   (action_tile "cancel" "(done_dialog 0)")
   (if (eq (start_dialog) 1) 
       (DN_AppendDim ss_dims dn_modifier dn_above)
   )
   (unload_dialog dcl_id)
   (setvar "cmdecho" cmd$)
  );progn
  (alert "Nebyl vybrn dn text kty pro pravu.")
);if
(princ)
)
