	;                                                                         ;
	; CREATED       ||   || || || //  |||                                     ;
	;        |||||  ||   || || ||||  || ||  |||||                             ;
	;   by          ||||  |||  || \\  |||                                     ;
	;                                                                         ;
	;                                                   copyright -LuK.O.-    ;

 ;											;
 ;			           ***** HLADINY *****					;
 ;											;

;											;
 ;			           ***** ERROR *****					;
 ;											;

(defun initerr ()					;init error
  (setq oldosnapcoord (getvar "osnapcoord"))
  (setq oldosmode (getvar "osmode"))
  (setq olddimzin (getvar "dimzin"))	 
  (setq oldlayer (getvar "clayer"))			;save settings
  (setq oldpick (getvar "pickbox"))
  (setq oldblipmode (getvar "blipmode"))
  (setq oldmenuecho (getvar "menuecho"))                   
  (setq oldhighlight (getvar "highlight"))
  (setq oldpickauto (getvar "pickauto"))
  (setq oldcmdecho (getvar "cmdecho"))
  (setq oldexprt (getvar "expert"))
  (setq temperr *error*)				;save *error*
  (setq *error* trap)					;reassign *error*
  (princ)
) ;defun
;;;*===========================================================
(defun trap (errmsg)					;define trap
  (command nil nil nil)
  (if (not (member errmsg '("console break" "Function Cancelled"))
      )
    (princ (strcat "\n*Error*  " errmsg " :-("))			;print message
  )
  (setvar "osnapcoord" oldosnapcoord)
  (setvar "osmode" oldosmode)
  (setvar "dimzin" olddimzin)
  (setvar "clayer" oldlayer)				;reset settings
  (setvar "blipmode" oldblipmode)
  (setvar "menuecho" oldmenuecho)
  (setvar "highlight" oldhighlight)
  (setvar "pickbox" oldpick)
  (setvar "pickauto" oldpickauto)
  (setvar "cmdecho" oldcmdecho)
  (setvar "expert" oldexprt)
  ;(terpri)
  (setq *error* temperr)				;restore *error*
) ;defun
;;;*===========================================================
(defun reset ()						;define reset
  (setq *error* temperr)				;restore *error*
  (setvar "osnapcoord" oldosnapcoord)
  (setvar "osmode" oldosmode)
  (setvar "dimzin" olddimzin)
  (setvar "clayer" oldlayer)				;reset settings
  (setvar "blipmode" oldblipmode)
  (setvar "menuecho" oldmenuecho)
  (setvar "highlight" oldhighlight)
  (setvar "pickbox" oldpick)
  (setvar "pickauto" oldpickauto)
  (setvar "cmdecho" oldcmdecho)
  (setvar "expert" oldexprt)
  (princ)
) ;defun

; nastaven aktuln hladiny dle vbru
(defun c:lplusplus(/ entita en en1 hladina *error* oldosnapcoord oldosmode olddimzin oldlayer oldblipmode oldmenuecho oldhighlight oldpick oldpickauto oldcmdecho oldexprt temperr)
  (initerr)
  (initget (+ 1 2))
  (princ "\nVyberte entitu, jej hladinu chcete mt aktuln: ")
  (setvar "pickauto" 0)
  (setq entita (ssget "_:S"))
  (while (not entita)
    (princ "\nVyberte entitu, jej hladinu chcete mt aktuln: ")
    (setq entita (ssget "_:S"))
  ) ;while
  (reset)
  (setq en (ssname entita 0))
  (setq en1 (entget en))
  (setq hladina (cdr (assoc 8 en1)))
  (setvar "clayer" hladina)
  (princ (strcat "aktuln hladina: " hladina))
  (princ)
) ;defun

; vypnut vech ostatnch hladin krom vybranch 
(defun c:lplus(/ hlad entita cntr hla layerList nazvy i n oldcmdecho oldexprt) 
  (princ "\nVyberte hladiny, kter chcete mt zapnut: ")
  (setq hlad (ssget))
  (while (not hlad)
    (princ "\nVyberte hladiny, kter chcete mt zapnut: ")
    (setq hlad (ssget))
  ) ;while
  (setq oldcmdecho (getvar "cmdecho")
	oldexprt (getvar "expert"))
  (setvar "cmdecho" 0)
  (setvar "expert" 0)
  (command "_layer" "_off" "*" "_yes" "")
  (setq cntr 0)
  (setq layerList (list))
  (while (< cntr (sslength hlad))
    (setq hla (entget (ssname hlad cntr)))
    (setq hla (cdr (assoc 8 hla)))
    (setq i 0)
    (foreach n layerList
      (progn
        (if (not (eq n hla))
 	  (setq i (1+ i))
        ) ;if
      ) ;progn
    ) ;foreach
    (if (eq (length layerList) i)
      (setq layerList (append (list hla) layerList))
    ) ;if 	 	
    (setq cntr (1+ cntr))
  ) ;while
  (foreach n layerList
    (command "_layer" "_on" n "")
  ) ;foreach
  (setvar "clayer" hla)
  (setvar "cmdecho" oldcmdecho)
  (setvar "expert" oldexprt)
  (princ "\nPro zapnut vech hladin pouijte pkaz 'lon'\n")
  (if (eq (length layerList) 1)
    (setq nazvy "Zapnut hladina je: ")
    (setq nazvy "Zapnut hladiny jsou: ")
  ) ;if
  (foreach n layerList
    (setq nazvy (strcat nazvy n ", "))
  ) ;foreach
  (princ nazvy)
  (princ)
) ;defun

; vypnut vybranch hladin 
(defun c:lminus(/ dotaz ent hlad *error* oldosnapcoord oldosmode olddimzin oldlayer oldblipmode oldmenuecho oldhighlight oldpick oldpickauto oldcmdecho oldexprt temperr)
  (initerr)
  (setvar "expert" 1)
  (setvar "cmdecho" 0)
  (setq dotaz T)
  (while (eq dotaz T)
    (initget "Undo Exit")
    (setq ent (entsel "\nVyberte entitu pro vypnut [Undo/Exit] <exit>: "))
    (if (null ent) (setq ent "Exit"))
    (cond
      ((eq ent "Undo")
       (progn
	 (cond
	   ((null hlad) (progn
			  ;(setq dotaz nil)
			  (princ "Nen co vracet...")
			) ;progn
	   ) ;null hlad
	   ((> (cdr (assoc 62 (tblsearch "LAYER" hlad))) 0) (princ "Vrtit se lze pouze o 1.krok")) ;
	   (T (progn
		(command "_layer" "_on" hlad "")
		(princ (strcat "Hladina " hlad " byla zapnuta."))
	      ) ;progn
	   ) ; T
	 ) ;cond
       ) ;progn
      ) ;undo
      ((eq ent "Exit") (setq dotaz nil)) ;exit
      (t (progn
	   (setq hlad (cdr (assoc 8 (entget (car ent)))))
	   (command "_layer" "_off" hlad "")
	   (princ (strcat "Hladina " hlad " byla vypnuta."))
	 ) ;progn
      ) ;entita
    ) ;cond
  ) ;while
  (if (< (cdr (assoc 62 (tblsearch "LAYER" (getvar "clayer")))) 0)
    (alert (strcat " Aktuln hladina " (getvar "clayer") " je vypnut!    "))
  ) ;if
  (princ "\nPro zapnut vech hladin pouijte pkaz 'lon'")
  (reset)
  (princ)
) ;defun

; fsechny hladiny ON 
(defun c:lon(/ oldcmdecho)
  (setq oldcmdecho (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command "_layer" "_on" "*" "")
  (setvar "cmdecho" oldcmdecho)
  (princ " Vechny hladiny jsou zapnut.")
  (princ)
) ;defun
