;=========================================================================
; KOTVYSK.lsp    Vkov kty   (Command function for AutoCAD)
; (c) Copyright 2007 ARmenu, GGmenu
; Version:   1.3 - Seiner
;-------------------------------------------------------------------------
; Author: ARmenu
; Update: PepaR (pepa.forum@centrum.cz)
; Thanks for developing: Alfred, Seiner, Pajda
;
; Description:
;
; Zjist vku a zape ji jako atribut bloku.
;
; Command options:
;  "VKS" Vkov kta
;  "VKO" Oprava hodnoty vkov kty
;  "VKNULA" Nastav potek (0,000) pro ktovn
;  "VKNULAZPET" Vrt potek (0,000) zpt na pvodn hodnotu
;============================================================================

(defun k-start ()
  (setq body nil)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  (setq vrstva (getvar "CLAYER"))
  (if (= (setq barva (getvar "CECOLOR")) "BYLAYER")
           (setq barva "BYLAYER")
  )
  (if (= (setq cara (getvar "CELTYPE")) "BYLAYER")
            (setq cara "BYLAYER")
  )
  (if (not (tblsearch "layer" "KOTY"))
    (progn
      (command "_LAYER" "_Make" "KOTY" "_Color" "4" "KOTY" "");esk volby pedlny na univerzln (p na _Make a b na _Color) - te funguje ve vech jazykovch mutacch
      (prompt "\nVytvoena hladina KOTY - barva 4 (svtle modr).")
    ) ; progn
  ) ; if
  (if (not (tblsearch "style" "ROMANS"))
    (progn
      (command "_STYLE" "ROMANS" "ROMANS.SHX" "0" "0.75" "0" "" "" "")
      (prompt "\nVytvoen styl psma ROMANS, soubor psma ROMANS, faktor ky 0.75, vka 0")
    ) ; progn
  ) ; if
  
  (command "_LAYER" "_S" "koty" ""
           "_COLOR" "_BYLAYER"
           "_LINETYPE" "_S" "_BYLAYER" ""
  )
)

(defun k-end ()
  (if body (vymaz_body))
  (setq *error* olderr olderr nil)
  (command "_LAYER" "_S" vrstva ""
           "_COLOR" barva
           "_LINETYPE" "_S" cara ""
  ) ; command

  (setvar "cmdecho" echo)
  (princ)
)

(defun zjisti_vysku (/ k y)
  (setq y (cdr (assoc 10 (entget ko)))) ;nacte do y hodnotu bodu
  (setq y (trans y 0 1)) ; prevede z globalniho do aktualniho USS
  (setq y (/ (cadr y) 1000))
  ;(setq y (/ (cadr (cdr (assoc 10 (entget ko)))) 1000)) ; zakomentovany puvodni prikaz
  
  (cond
    ((> y 0) (setq text (strcat "+" (rtos y 2 3))))
    ((= y 0) (setq text "0,000"))
    ((< y 0) (setq text (rtos y 2 3)))
  ) ; cond

  (setq k (entnext ko))
  (setq k (entget k))
  (setq k (subst (cons '1 (vl-string-subst "," "." text)) (assoc 1 k) k))
  (entmod k)
  (entupd ko)
) ; defun

(defun VKS (jm_bloku)  ; vkov kta
  (setq atrvloz (getvar "attreq"))
  (setvar "attreq" 0)
  (k-start)

  (prompt "\nUka bod umstn kty :")
  (command "_INSERT" jm_bloku pause (getvar "dimscale") "" "")
  (setq ko (entlast))
  (zjisti_vysku)
  (k-end)
  (setvar "attreq" atrvloz)
)

(defun fld (n)
  (cdr (assoc n d))
)

(defun C:VKO ()    ;  oprava hodnoty u vk. kot
  (k-start)
  
  (while (setq ko (car (entsel "\nVyber vkovou ktu pro aktualizaci :")))
    (setq d (entget ko))
    (if (and (= (fld 0) "INSERT")
             (or (= (fld 2) "KOTAVYSK")
                 (= (fld 2) "vk1")
                 (= (fld 2) "vk2")
                 (= (fld 2) "vk3")
                 (= (fld 2) "vk4")
                 (= (fld 2) "vk5")
                 (= (fld 2) "vk6")
                 (= (fld 2) "vk7")
                 (= (fld 2) "vk8")
                 (= (fld 2) "VK1")
                 (= (fld 2) "VK2")
                 (= (fld 2) "VK3")
                 (= (fld 2) "VK4")
                 (= (fld 2) "VK5")
                 (= (fld 2) "VK6")
                 (= (fld 2) "VK7")
                 (= (fld 2) "VK8")
             ) ; or
        ) ; and
     (zjisti_vysku)
     (prompt "\nNen vykov kota.")
    ) ; if
  ) ; while
  
  (k-end)
) ; defun

(defun C:VKNULA ()    ;  nastaven potku pro ktovn
  (print)
  (setq P1 (getpoint "Zvolte nov potek (0,000) <0,0,0>:"))
  (command "_UCS" "_DELETE" "*")
  (command "_UCS"  "_SAVE" "NULAVK")
  (command "_UCS" "_New" P1)
  (print)
) ; defun

(defun C:VKNULAZPET ()    ;  vrt zpt pvodn potek
  (command "_UCS" "_restore" "NULAVK")
  (print)
  (princ "Potek (0,0,0) byl vrcen na pvodn hodnotu.")
  (print)
) ; defun

