;=========================================================================
; KOTVYSK.lsp    Vkov kty   (Command function for AutoCAD)
; (c) Copyright 2007 ARmenu, GGmenu
; Version:   1.3 - Seiner
; verze: 1.54.001-CZ - alfred
;-------------------------------------------------------------------------
; Author: ARmenu
; Update: PepaR (pepa.forum@centrum.cz)
; Thanks for developing: Alfred, Seiner, Pajda
;
; Description:
;
; Zjist vku a zape ji jako atribut bloku.
;
; Command options:
;  "VKS" Vkov kta - vkld blok 'Kota_vysky_R_GG' nebo 'Kota_vysky_R_GG.dwg'
;  "VKS-POLE" Vkov kta s polem - automaticky je v poli zobrazena souradnice Y mista vlozeni bloku.
;             Vklada blok 'Kota_vysky_R_GG-POLE' (Kota_vysky_R_GG-POLE.dwg). U tohoto bloku se pro kladne hodnoty NEZOBRAZUJE znamenko "+".
;  "VKO" Oprava hodnoty vkov kty "Kota_vysky_R_GG" a predchozich "vk1, vk2, ... vk8, vkota, KOTAVYSK"
;  "VKNULA" Nastav potek (0,000) pro ktovn
;  "VKNULAZPET" Vrt potek (0,000) zpt na pvodn hodnotu
;  "VKS-NADM" - pidna funkce, kter vkld ktu bez vodnho plusu
;
;======================================================================================
;NASTAVEN:

; nastaveni nazvu bloku pro funkce: VKS, VKS-NADM, VKO 
(SETQ GGmenu-jmeno_bloku-staticka_kacena "Kota_vysky_R_GG")            ;originalni nazev bloku: "Kota_vysky_R_GG"

; nastaveni nazvu bloku pro funkce: VKS-POLE
(SETQ GGmenu-jmeno_bloku-kacena+pole-mm "Kota_vysky_R_GG-POLE-mm")     ;originalni nazev bloku: "Kota_vysky_R_GG-POLE-mm"
(SETQ GGmenu-jmeno_bloku-kacena+pole-m "Kota_vysky_R_GG-POLE-m")       ;originalni nazev bloku: "Kota_vysky_R_GG-POLE-m"

;============================================================================
(defun k-err (msg)
  (setq *error* olderr olderr nil)
  (if olddimzin (progn (setvar "dimzin" olddimzin)(setq olddimzin nil)))
  (if atrvloz   (progn (setvar "attreq" atrvloz)  (setq atrvloz nil)))
  (if oldosmode (progn (setvar "osmode" oldosmode)(setq oldosmode nil)))
  (print msg)
  (princ)
)

;============================================================================
(defun zjisti_vysku (ko nasobitel prefix / k y HODNOTA_KOTY)
  	;nasobitel:
  	;	- pro mm nasobitel=1000; pro
  	;	- pro m nasobitel=1; pro 
  (setq y (cdr (assoc 10 (entget ko)))) ;nacte do y hodnotu bodu
  (setq y (trans y 0 1)) ; prevede z globalniho do aktualniho USS
  (setq y (cadr y))
  (if (< (abs y) 1e-011)(setq y 0)) ; melo by korigovat nepresnosti AutoCadu
  
  (setq HODNOTA_KOTY (/ y nasobitel))
  ;(setq y (/ (cadr (cdr (assoc 10 (entget ko)))) 1000)) ; zakomentovany puvodni prikaz
  
  (cond
    ((> y 0) (setq text (strcat prefix (rtos HODNOTA_KOTY 2 (getvar "LUPREC")))))
    ((= y 0) (setq text (strcat "%%P" (rtos 0.0 2 (getvar "LUPREC")))))
    ((< y 0) (setq text (rtos HODNOTA_KOTY 2 (getvar "LUPREC"))))
  ) ; cond

  (setq k (entnext ko))
  (setq k (entget k))
  (setq k (subst (cons '1 (vl-string-subst "," "." text)) (assoc 1 k) k))
  (entmod k)
  (entupd ko)

  (princ)
) ; defun

;============================================================================
;pouziti funkce  - (v_atributu_je_cislo JMENO_ENTITY_S_BLOKU_S_ATRIBUTEM)
(defun v_atributu_je_cislo (entita / entita-atribut obsah_atributu n str is_text)
  (setq entita-atribut (entnext entita))
  (if (/= entita-atribut nil)
    (progn
	  (if (= (cdr (assoc 0 (entget entita-atribut))) "ATTRIB")
	    (progn
		  (setq obsah_atributu (cdr (assoc 1 (entget entita-atribut))))
		  (setq is_text T); pedpoklad, e je vybrn text s slem
		  (setq n 1)

		  (if (= (strcase (substr obsah_atributu n 3)) "%%P")
		    (setq n 4)
		    )
		  (repeat (+ (- (strlen obsah_atributu) n) 1)
		    (setq str (substr obsah_atributu n 1))
		    (if	(= is_text T)
		      (progn
			(if (or	(= str "1")
				(= str "2")
				(= str "3")
				(= str "4")
				(= str "5")
				(= str "6")
				(= str "7")
				(= str "8")
				(= str "9")
				(= str "0")
				(= str ".")
				(= str ",")
				(and (= str "+") (= n 1) (> (strlen obsah_atributu) 1))
				(and (= str "-") (= n 1) (> (strlen obsah_atributu) 1))
			    );konec podmnky
			  (princ)
			  (progn
			    ;(princ " ...Text neobsahuje slo!!!")
			    (setq is_text nil)
			  );progn
			);if
		      );progn
		    );if
		    (setq n (+ n 1))
		  );repeat
	     );progn
	    (progn
	      (print (strcat "vybran blok '"
				 (cdr (assoc 2 (entget entita)))
				 "' neobsahuje atribut - nelze pokraovat!!! Pravdpodobn vkldte chybn blok ")
	      )
	      (setq is_text nil)
	     )
	  );if
      );progn
      (progn
	      (print (strcat "vybran blok '"
				 (cdr (assoc 2 (entget entita)))
				 "' neobsahuje atribut - nelze pokraovat!!! Pravdpodobn vkldte chybn blok ")
	      )
	      (setq is_text nil)
     )
    );if
  ;navratova hodnota funkce "true/false" - musi byt na konci funkce!!!
  is_text
);defun


;============================================================================
(defun C:VKNULA ( / P1 pozadovana_vyska)    ;  nastaven potku pro ktovn
  (setq olderr *error*) (setq *error* k-err)
  ;(setq P1 (getpoint "Zvolte nov potek (0,000) <0,0,0>:"))
  (setq P1 (getpoint "Ukate novou srovnvac rovinu: "))
  (if (/= P1 nil)
    (progn
	  (setq pozadovana_vyska (getreal "Zadejte vku srovnvac roviny [m] <ENTER pro 0.000 m>: "))
	  (if (= pozadovana_vyska nil)
	    (setq pozadovana_vyska 0)
	  )
	  (cond
	      ((= 4 (getvar "INSUNITS" ))(setq pozadovana_vyska (* pozadovana_vyska 1000))); jednotky jsou milimetry
	      ((= 6 (getvar "INSUNITS" ))(setq pozadovana_vyska (* pozadovana_vyska 1)))   ; jednotky jsou metry
	      ((print "Ve vkrese nejsou nastaveny jednotky na 'm' nebo 'mm'. Zadanou vku [m] nelze pevst na vkresov jednotky!!"))
	  );cond

	  (setq P1 (list
		     (nth 0 P1)
		     (- (nth 1 P1) pozadovana_vyska)
		     (nth 2 P1)
		   )
	  )
	  ;(command "_UCS" "_DELETE" "*")
	  (command "_UCS" "_DELETE" "NULAVK")
	  (command "_UCS"  "_SAVE" "NULAVK")
	  (command "_UCS" "_New" P1)
      )
      (print "Nastaven srovnvac roviny zstalo na pvodn hodnot.")
    )
  (setq *error* olderr olderr nil)
  (print "Konec...")
  (print)
) ; defun

;============================================================================
(defun C:VKNULAZPET ()    ;  vrt zpt pvodn potek
  (if (tblsearch "ucs" "nulavk")
    (progn
      (command "_UCS" "_restore" "NULAVK")
      (print "Potek (0,0,0) byl vrcen na pvodn hodnotu.")
    )
    (print "Nelze obnovit pedchoz potek - nen uloen USS s nzvem 'NULAVK'")
  );if
  (print "Konec...")
  (print)
) ; defun

;============================================================================
;  oprava hodnoty u vk. kot
(defun C:VKO ( / ko d selekce i blname pocet_modifikovanych pocet_bez_cisla nasobitel prvni_znak)
  (vl-load-com)
  (setq echo (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq olderr *error*)
  (setq *error* k-err)
  ;zjisteni jednotek
  (setq nasobitel nil)
  (cond
      ((= 4 (getvar "INSUNITS" ))(setq nasobitel 1000))
      ((= 6 (getvar "INSUNITS" ))(setq nasobitel 1))
      ((print "Ve vykrese nejsou nastaveny jednotky na 'm' nebo 'mm'. Nelze aktualizovat hodnotu vky.")(setq nasobitel 0))
  );cond
  (if (> nasobitel 0)
   (progn
    (setq selekce nil)
    (prompt "\nVyberte vkov kty")
    (if (setq selekce (ssget '((0 . "INSERT"))))
      (progn
            (setq i 0)
            (setq pocet_modifikovanych 0)
      	    (setq pocet_bez_cisla 0)
      
	    (while (ssname selekce i)
	      (setq ko (ssname selekce i))
	      ;(setq ko (car (entsel "\nVyberte vkovou ktu pro aktualizaci :")))
	       (setq d (entget ko))
	       (setq olddimzin (getvar "dimzin"))
	       (setvar "dimzin" 0)
	       ;(setq blname (cdr (assoc 2 d)))
	      ; zjisteni jmena bloku (nutno takhle - u dynamickych bloku je jmeno *U*
	       (setq blname (vla-get-effectivename (vlax-ename->vla-object ko)))

	       
	       (if   ; jmeno bloku je v listu
		    (/= nil
		      (vl-position blname
			      (list GGmenu-jmeno_bloku-staticka_kacena
				    "vk1"    "vk2"    "vk3"
				    "vk4"    "vk5"    "vk6"    "vk7"
				    "vk8"    "vkota"  "KOTAVYSK" 
				    "VK1"    "VK2"    "VK3"    "VK4"
				    "VK5"    "VK6"    "VK7"    "VK8" "VKOTA"
				     )
		      )
		     ); konec podminky
		     (progn
		       (if (v_atributu_je_cislo ko)
			 (progn
				(setq hodnota-string (cdr (assoc 1 (entget (entnext ko)))))
				(setq prvni_znak (substr hodnota-string 1 1))
				(cond
				  ((vl-position prvni_znak (list "0" "1" "2" "3" "4" "5" "6" "7" "8" "9")) (zjisti_vysku ko nasobitel ""));pedpoklad - nadmosk vka
				  ( (vl-position prvni_znak (list "+" "-" "%")) (zjisti_vysku ko nasobitel "+")); pedpoklad - relativn kta
				);cond
	   	            ;(zjisti_vysku ko nasobitel "+")
			    (setq pocet_modifikovanych (+ 1 pocet_modifikovanych))
			 )
			 (progn
			   (print (strcat "v atributu bloku '" blname "' neni cislo"))
			   (setq pocet_bez_cisla (+ 1 pocet_bez_cisla))
			 )
		       );if
		     );progn
		     (print "Nen vkov kota.")
	       ); if
               (setq i (+ i 1))
	    ); while
      	    (print (strcat "Bylo upraveno "
			   (rtos pocet_modifikovanych 2 0)
			   " blok z "
			   (rtos (sslength selekce) 2 0)
			   " vybranch. "
			   (rtos pocet_bez_cisla 2 0)
			   " blok nebylo aktualizovno, protoe neobsahovalo v atributu slo."
	           );strcat
	    );print
      	    (setvar "dimzin" olddimzin)
	    (setq olddimzin nil)
	  );progn
          (print "dn vbr")
    );if
   );progn
  );if


  (setq *error* olderr olderr nil)
  (setvar "cmdecho" echo)
  (print "Konec...")
  (princ)
) ; defun

;============================================================================
; vloen vkov kty - blok s nzvem "Kota_vysky_R_GG" (hodnota ulozena v promenne 'GGmenu-jmeno_bloku-staticka_kacena')
;- do vykresu kreslenem v metrech nebo v milimetrech
(defun c:VKS (/ jm_bloku olddimzin atrvloz ko inspoint echo)  
  (setq jm_bloku GGmenu-jmeno_bloku-staticka_kacena)
  (setq nasobitel 1)
  (cond
      ((= 4 (getvar "INSUNITS" ))(setq nasobitel 1000)) ;mm
      ((= 6 (getvar "INSUNITS" ))(setq nasobitel 1))    ;metry
      (
       (alert
	"Ve vykrese nejsou nastaveny jednotky na 'm' nebo 'mm'.
	Pro sprvn fungovn funkce a nastaven mtka bloku 
	je nutn mt sprvn nastaveny jednotky!!! Mtko vloen
	bloku vk. koty bude nastaveno podle promnn 'DIMSCALE'
	a dle standardnho chovn AutoCADu pro vkldn blok rznch jednotek.
	Jednotky se nastavuj pkazem 'UNITS'."
       ) ;alert
      )
  );cond

  (if (or (tblsearch "block" jm_bloku) (findfile (strcat jm_bloku ".dwg")))
    (progn
	  (setq olddimzin (getvar "dimzin")) (setvar "dimzin" 0)
      	  (setq oldosmode (getvar "osmode")) 
	  (setq atrvloz (getvar "attreq"))   (setvar "attreq" 0)
          (setq echo (getvar "cmdecho"))     (setvar "cmdecho" 0)
          (setq olderr *error*)              (setq *error* k-err)

	  (setq inspoint 0)
	  (while (/= inspoint nil)
	    (setq inspoint (getpoint "\nUkate bod umstn kty : "))
	    (if (/= inspoint nil)
	      (progn
		 (setvar "osmode" 0)
	   	 ;(command "_INSERT" jm_bloku pause (getvar "dimscale") "" "")
	   	 ;(command "_INSERT" jm_bloku pause (getvar "dimscale") "")
		 (command "_INSERT" jm_bloku inspoint (* (/ 1000 nasobitel) (getvar "dimscale")) "")
		 (setvar "osmode" oldosmode)
	   	 (setq ko (entlast))
		 (if (/= (entnext ko) nil)
		      (zjisti_vysku ko nasobitel "+")
		      (progn
			(print (strcat "Error: Vloen blok '"
				 (cdr (assoc 2 (entget ko)))
				 "' neobsahuje atribut - nelze zapsat vku!!! Pravdpodobn vkldte chybn blok. ")
	      		)
		      );
		 );if
	      )
	    );if
	  );while

  	  (setq *error* olderr olderr nil)
  	  (setvar "cmdecho" echo)
          (setq oldosmode nil)
	  (setvar "dimzin" olddimzin)(setq olddimzin nil)
	  (setvar "attreq" atrvloz)(setq atrvloz nil)
      );progn
    (print (strcat "Blok '" jm_bloku "' s vykovou ktou nelze najt. Konec."))
    );if
  (print "Konec...")
  (print)
)

;============================================================================
; vloen vkov kty - blok s nzvem "Kota_vysky_R_GG" (hodnota ulozena v promenne 'GGmenu-jmeno_bloku-staticka_kacena')
; - do vykresu kreslenem v metrech nebo v milimetrech
(defun c:VKS-nadm (/ jm_bloku olddimzin atrvloz ko inspoint echo)  
  (setq jm_bloku GGmenu-jmeno_bloku-staticka_kacena)
  (setq nasobitel 1)
  (cond
      ((= 4 (getvar "INSUNITS" ))(setq nasobitel 1000)) ;mm
      ((= 6 (getvar "INSUNITS" ))(setq nasobitel 1))    ;metry
      (
       (alert
	"Ve vykrese nejsou nastaveny jednotky na 'm' nebo 'mm'.
	Pro sprvn fungovn funkce a nastaven mtka bloku 
	je nutn mt sprvn nastaveny jednotky!!! Mtko vloen
	bloku vk. koty bude nastaveno podle promnn 'DIMSCALE'
	a dle standardnho chovn AutoCADu pro vkldn blok rznch jednotek.
	Jednotky se nastavuj pkazem 'UNITS'."
       ) ;alert
      )
  );cond

  (if (or (tblsearch "block" jm_bloku) (findfile (strcat jm_bloku ".dwg")))
    (progn
	  (setq olddimzin (getvar "dimzin")) (setvar "dimzin" 0)
      	  (setq oldosmode (getvar "osmode")) 
	  (setq atrvloz (getvar "attreq"))   (setvar "attreq" 0)
          (setq echo (getvar "cmdecho"))     (setvar "cmdecho" 0)
          (setq olderr *error*)              (setq *error* k-err)

	  (setq inspoint 0)
	  (while (/= inspoint nil)
	    (setq inspoint (getpoint "\nUka bod umstn kty : "))
	    (if (/= inspoint nil)
	      (progn
		 (setvar "osmode" 0)
		 (command "_INSERT" jm_bloku inspoint (* (/ 1000 nasobitel) (getvar "dimscale")) "")
		 (setvar "osmode" oldosmode)
	   	 (setq ko (entlast))
		 (if (/= (entnext ko) nil)
		      (zjisti_vysku ko nasobitel "")
		      (progn
			(print (strcat "Error: Vloen blok '"
				 (cdr (assoc 2 (entget ko)))
				 "' neobsahuje atribut - nelze zapsat vku!!! Pravdpodobn vkldte chybn blok. ")
	      		)
		      );
		 );if
	      )
	    );if
	  );while

  	  (setq *error* olderr olderr nil)
  	  (setvar "cmdecho" echo)
          (setq oldosmode nil)
	  (setvar "dimzin" olddimzin)(setq olddimzin nil)
	  (setvar "attreq" atrvloz)(setq atrvloz nil)
      );progn
    (print (strcat "Blok '" jm_bloku "' s vkovou ktou nelze najt. Konec."))
    );if
  (print "Konec...")
  (print)
)

;============================================================================
; vloen vkov kty - blok s nzvem "Kota_vysky_R_GG-POLE" (ULOZENO V PROMENNE 'GGmenu-jmeno_bloku-kacena+pole')
(defun c:VKS-POLE (/ jm_bloku olddimzin atrvloz inspoint echo)
  (print "Funkce vkld blok s textovm polem, kter automaticky zobrazuje hodnotu souadnice Y. Hodnota se aktualizuje pi regeneraci nebo tisku. Pro kladn hodnoty nelze automaticky zobrazit znamnko '+'.")
  (setq jm_bloku GGmenu-jmeno_bloku-kacena+pole-m );
  (cond
      ((= 4 (getvar "INSUNITS" ))(setq jm_bloku GGmenu-jmeno_bloku-kacena+pole-mm)) ;mm
      ((= 6 (getvar "INSUNITS" ))(setq jm_bloku GGmenu-jmeno_bloku-kacena+pole-m ))  ;metry
      (
       (alert
	"Ve vykrese nejsou nastaveny jednotky na 'm' nebo 'mm'.
	Pro sprvn fungovn funkce a nastaven mtka bloku 
	je nutn mt sprvn nastaveny jednotky!!! Bude pouit blok pro jednotky 'metr'.
	Mtko vloen bloku vk. koty bude nastaveno podle promnn 'DIMSCALE'
	a dle standardnho chovn AutoCADu pro vkldn blok rznch jednotek.
	Jednotky se nastavuj pkazem 'UNITS'."
       ) ;alert
    
       )
    );cond
  
  
  ;(setq jm_bloku GGmenu-jmeno_bloku-kacena+pole)
  (if (or (tblsearch "block" jm_bloku) (findfile (strcat jm_bloku ".dwg")))
    (progn
	  (setq olddimzin (getvar "dimzin")) (setvar "dimzin" 0)
      	  (setq oldosmode (getvar "osmode")) 
	  (setq atrvloz (getvar "attreq"))   (setvar "attreq" 0)
          (setq echo (getvar "cmdecho"))     (setvar "cmdecho" 0)
          (setq olderr *error*)              (setq *error* k-err)
	  (setq inspoint 0)
	  (while (/= inspoint nil)
	    (setq inspoint (getpoint "\nUka bod umstn kty : "))
	    (if (/= inspoint nil)
	      (progn
	         (setvar "osmode" 0)
	   	 ;(command "_INSERT" jm_bloku pause (getvar "dimscale") "" "")
	   	 ;(command "_INSERT" jm_bloku pause (getvar "dimscale") "")
		 (command "_INSERT" jm_bloku inspoint (getvar "dimscale") "")
		 (setvar "osmode" oldosmode)
	      )
	    );if
	  );while

  	  (setq *error* olderr olderr nil)
  	  (setvar "cmdecho" echo)
          (setq oldosmode nil)
	  (setvar "dimzin" olddimzin)(setq olddimzin nil)
	  (setvar "attreq" atrvloz)(setq atrvloz nil)
      );progn
    (print (strcat "Blok '" jm_bloku "' s vykovou ktou nelze najt. Konec."))
    );if
  ;(print "Poznmka: Vypnut rmeku PEKRYT se provede pomoc volby 'Rmeky' v pkazu 'PEKRT'.")
  (print "Konec...")
  (print)
)



;======================================================================================
;hlka pi natn
(print "Natena funkce pro vkov kty. Spout se:")
(print (strcat "    'VKS' ... vloen relativn vkov kty  (blok '" GGmenu-jmeno_bloku-staticka_kacena "') "))
(print (strcat "    'VKO' ... aktualizace bloku vkov kty '" GGmenu-jmeno_bloku-staticka_kacena " ' "))
(print (strcat "    'VKS-POLE' ... vloen vkov kty s dynamickm polem :"))
(print (strcat "     '" GGmenu-jmeno_bloku-kacena+pole-m "' nebo '" GGmenu-jmeno_bloku-kacena+pole-mm "' (dle jednotek)"))
(print (strcat "    'VKS-NADM' ... vloen vkov kty s nadmoskou vkou '" GGmenu-jmeno_bloku-staticka_kacena "'"))
(print "    'VKNULA'      ... nastaven nov srovnvac rovony")
(print "    'VKNULAZPET'  ... nastaven pedchoz srovnvac roviny")
(PRINC)
