;=========================================================================
; OVAL.lsp   Draw Oval  (Command function for AutoCAD) 
; (c) Copyright 2001 TimeSavers for CAD
; from: www.timesaversforcad.com
;-------------------------------------------------------------------------
; Description:
; 
; Draws polyline oval.
;=========================================================================
(defun c:oval (/ *ovl:err* c_e c1 c2 r ang o1 o2 o3 o4 ce)

  ;-ERROR HANDLING
  (defun *ovl:err* (m)
    (or (member m '("Funkce zruena" "_quit / _exit _abort" "console break"))
        (prompt (strcat "\n< " m " >\n"))
    )
    (if ce (entdel ce))(setvar "cmdecho" c_e)
    (setq *error* *e*)(princ)
  )

  ;-GET VALUES
  (setq *e* (cond (*e*)(*error*))
        *error* *ovl:err*
        c_e (getvar "cmdecho")
  )

  ;-MAIN FUNCTION
  (if (setq c1 (getpoint "\nPoten a koncov bod oblu <bod stedu oblouku>: "))
    (progn
      (prompt "\nPolomr ovlu <bod>: ")
      (setvar "cmdecho" 0)
      (command "_circle" c1 pause)
      (setq ce (entlast))
      (prompt "\nDal koncov bod ovlu: ")
      (command "_move" "_l" "" c1 pause)
      (setq c2 (cdr (assoc 10 (entget (entlast)))) ;center of 2nd circle for oval
            r (cdr (assoc 40 (entget (entlast))))  ;Radius for oval
            ang (angle c1 c2)                      ;angle for oval
            o1 (polar c1 (+ ang (/ pi 2)) r)
            o2 (polar c1 (- ang (/ pi 2)) r)
            o3 (polar c2 (- ang (/ pi 2)) r)
            o4 (polar c2 (+ ang (/ pi 2)) r)
      )
      (entdel ce)
      (command "_pline" o1 "_w" 0 0 "_a" "_ce" c1 o2 "_l" o3 "_a" o4 "_l" "_c")
    )
  )

  ;-RETURN VALUES
  (setvar "cmdecho" c_e)
  (setq *error* *e*)(princ)
)
;-END FILE
