	;                                                                         ;
	; CREATED       ||   || || || //  |||                                     ;
	;        |||||  ||   || || ||||  || ||  |||||                             ;
	;   by          ||||  |||  || \\  |||                                     ;
	;                                                                         ;
	;                                                   copyright -LuK.O.-    ;

 ;											;
 ;			           ***** ERROR *****					;
 ;											;

(defun initerr ()					;init error
  (setq oldosnapcoord (getvar "osnapcoord"))
  (setq olddimzin (getvar "dimzin"))	 		;save settings
  (setq oldcmdecho (getvar "cmdecho"))
  (setq temperr *error*)				;save *error*
  (setq *error* trap)					;reassign *error*
  (princ)
) ;defun
;;;*===========================================================
(defun trap (errmsg)					;define trap
  (command nil nil nil)
  (if (not (member errmsg '("console break" "Function Cancelled"))
      )
    (princ (strcat "\n*Chyba*  " errmsg " :-("))			;print message
  )
  (setvar "osnapcoord" oldosnapcoord)
  (setvar "dimzin" olddimzin)				;reset settings
  (setvar "cmdecho" oldcmdecho)
  ;(terpri)
  (setq *error* temperr)				;restore *error*
) ;defun
;;;*===========================================================
(defun reset ()						;define reset
  (setq *error* temperr)				;restore *error*
  (setvar "osnapcoord" oldosnapcoord)	
  (setvar "dimzin" olddimzin)				;reset settings
  (setvar "cmdecho" oldcmdecho)
  (princ)
) ;defun

 ;											;
 ;			           ***** PARABOLA *****					;
 ;     Zadn: potek, konec, libovoln bod paraboly                                   ;

(defun c:par(/ point point1 point2 pt1 pt2 f1 L e int uloz name name1 file xi z yi sour sourm x0 y0 zero tecna start end start1 end1 oldosnapcoord olddimzin oldcmdecho temperr *error* t1 t2) 
  (initerr)
  ; nastaven sys. promnnch
  (setvar "dimzin" 0)
  (setvar "osnapcoord" 1)
  (setvar "cmdecho" 0)
  ; po a konc bod
  (initget (+ 1 2 4))
  (setq point1 (getpoint "\nZadejte prvn bod paraboly: "))
  (setq point2 (getpoint point1 "\nZadejte druh bod paraboly: "))
  (if (> (car point1) (car point2))
	      (setq pt1 point2 pt2 point1)
    	      (setq pt1 point1 pt2 point2)
  ) ;if
  ; dlka paraboly L
  (setq L (abs (- (car pt2) (car pt1))))
  ; exentricita
  (setq e (- (cadr pt2) (cadr pt1)))
  (princ (strcat "\n*** Excentricita je " (rtos e 2 3) " ***"))
  ; vzept
  (initget (+ 1 2 4))
  (setq point (getpoint "\nZadejte libovoln bod paraboly: "))
  (setq f (/ (- (- (cadr point) (cadr pt1)) (* e (- (car point) (car pt1)) (/ 1.0 L)))
	     (- (* 4.0 (- (car point) (car pt1)) (/ 1.0 L)) (* 4.0 (expt (- (car point) (car pt1)) 2.0) (/ 1.0 (expt L 2.0))))))
  ; dotaz na uloen do textaku
  (initget 2 "Ano Ne")
  (setq uloz (getkword "\nUloit souadnice paraboly do txt souboru? [Ano/Ne] <Ne>: "))
  (if (null uloz) (setq uloz "Ne"))
  (if (= uloz "Ano")
    (setq name (getfiled "Zadejte prosm nzev souboru" "c:/" "txt" 1))
  ) ;if
  (if (null name)
    (setq name1 (strcat (getvar "DWGPREFIX") "parabol.txt"))
    (setq name1 name)
  ) ;if
  (if (= uloz "Anp")
    (progn
      (setq file (open name1 "a"))
      (write-line "Vpis souadnic paraboly \nLokln systm \n***Poten bod***" file)
      (close file)
    ) ;progn
  ) ;if
  ; dlen paraboly
  (setq int (/ L 100.0))  ; dlen na 100 dl
  (setq xi 0 z 0) 
  ; cyklus
  (while (<= xi L) 
    (setq yi (+ (/ (* -4.0 f (expt xi 2.0)) (expt L 2.0)) (/ (* 4.0 f xi) L) (/ (* e xi) L)))
    (if (= uloz "Ano")
      (progn
	(setq file (open name1 "a"))
	(write-line (strcat (rtos xi 2 12) "\t" (rtos yi 2 12) "\t") file)
	(close file)
      ) ;progn
    ) ;if
    (setq sour (list (+ (car pt1) xi) (+ (cadr pt1) yi) 0.0))
           (if (= z 0)
      	   (progn
	     (command "_SPLINE" sour)
	   ) ;progn
           (progn (command sour))
    	 ) ;if
    (setq sourm sour)
    (setq z (1+ z))
    (setq xi (+ xi int))
  ) ;while
  (setq t1 (polar pt1 (+ (atan (+ (/ (* 4.00 f) L) (/ e L))) pi) 1.0)
	t2 (polar pt2 (atan (+ (/ (* -4.0 f) L) (/ e L))) 1.0)
  ) ;setq
  (command "" t1 t2)
  (setq x0 (* (+ (* 4.0 f) e) (/ L (* 8.0 f)))  
	y0 (+ (/ (* -4.0 f (expt x0 2.0)) (expt L 2.0)) (/ (* 4.0 f x0) L) (/ (* e x0) L))
  ) ;setq
  (if (= uloz "Ano")
    (progn
      (setq file (open name1 "a"))
      (write-line (strcat "***Koncov bod*** \nNulov tena paraboly je [" (rtos x0 2 2) "," (rtos y0 2 2) "] od potenho bodu.") file)
      (close file)
    ) ;progn
  ) ;if
  (initget 2 "Ano Ne")
  (setq zero (getkword (strcat "\nNulov tena paraboly je [" (rtos x0 2 2) "," (rtos y0 2 2) "] zleva od potenho bodu.\nPejete si jej vytvoit? [Ano/Ne] <Ne>: ")))
  (if (null zero) (setq zero "Ne"))
  (if (= zero "Ano")
    (command "_line" (list (+ (car pt1) (- x0 (/ L 3.0))) (+ (cadr pt1) y0) 0.0) (list (+ (car pt1) x0 (/ L 3.0)) (+ (cadr pt1) y0) 0.0) "")
  ) ;if
  (while (setq tecna (getpoint "\nZadejte bod teny <exit>: "))
    (setq start (list
		  (- (car tecna) (car pt1))
		  (+ (/ (* -4.0 f (expt (- (car tecna) (car pt1)) 2.0)) (expt L 2.0)) (/ (* 4.0 f (- (car tecna) (car pt1))) L) (/ (* e (- (car tecna) (car pt1))) L))
		  0.0
		) ;list
    ) ;setq
    (setq end (polar start (atan (+ (/ (* -8.0 f (- (car tecna) (car pt1))) (expt L 2.0)) (/ (* 4.0 f) L) (/ e L))) (/ L 3.0)))
    (setq start1 (list
		   (+ (car pt1) (car start)) ;x
		   (+ (cadr pt1) (cadr start)) ;y
		   0.0
		 ) ;list
          end1 (list
		 (+ (car pt1) (car end)) ;x
		 (+ (cadr pt1) (cadr end)) ;y
		 0.0
	       ) ;list 
    ) ;setq
    (command "_line" start1 end1 "") 
  ) ;while
  (princ)
  (reset) 	; vrcen nastaven uivatele 
) ;defun
